"""Added CreatedBy to form details

Revision ID: 74e4c8045567
Revises: 863c807f22bd
Create Date: 2022-04-20 13:51:31.024245+02:00

"""
import sqlalchemy as sa
from alembic import op
from enum import Enum
from sqlalchemy.orm import DeclarativeMeta, declarative_base

Base: DeclarativeMeta = declarative_base()

# revision identifiers, used by Alembic.
revision = "74e4c8045567"
down_revision = "863c807f22bd"
branch_labels = None
depends_on = None


class Rights(str, Enum):
    VIEWER = "VIEWER"
    EDITOR = "EDITOR"
    OWNER = "OWNER"


class FormDetails(Base):
    __tablename__ = "form_details"
    sid = sa.Column(
        sa.Integer,
        sa.Sequence("form_details_sid_seq", metadata=Base.metadata),
        primary_key=True,
        index=True,
    )
    author = sa.Column(sa.Integer, sa.ForeignKey("organization.sid"), nullable=False)


class FormManagement(Base):
    __tablename__ = "form_management"
    sid = sa.Column(sa.Integer, primary_key=True, index=True)
    form_details_sid = sa.Column(sa.Integer, sa.ForeignKey("form_details.sid"), nullable=False)
    organization_sid = sa.Column(sa.Integer, sa.ForeignKey("organization.sid"), nullable=False)
    rights = sa.Column(sa.Enum(Rights), nullable=False)


class Organization(Base):
    __tablename__ = "organization"
    sid = sa.Column(
        sa.Integer,
        primary_key=True,
        index=True,
    )
    name = sa.Column(sa.String, index=True, unique=True, nullable=False)


def upgrade():
    """Upgrade"""
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column("form_details", sa.Column("author", sa.Integer(), nullable=True))
    op.create_foreign_key("fc_author", "form_details", "organization", ["author"], ["sid"])
    # ### end Alembic commands ###

    # update the owners where we have one

    op.execute(
        "update form_details "
        "set author=form_management.organization_sid "
        "from form_management "
        "where form_management.form_details_sid = form_details.sid "
        "and form_management.rights = 'OWNER'"
    )

    op.execute(
        "update form_details "
        "set author=organization.sid "
        "from organization "
        "where form_details.author is null and organization.\"name\" = 'Exxellence';"
    )

    op.execute(
        "update form_details set author=(select min(sid) from organization) where author is null"
    )

    op.alter_column("form_details", "author", nullable=False)


def downgrade():
    """Downgrade"""
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint("fc_author", "form_details", type_="foreignkey")
    op.drop_column("form_details", "author")
    # ### end Alembic commands ###
